// ============================================================================
// Default spacings
// ================
// Add default margin (bottom) to all paragraphs if no value is set in the
// paragraphs settings.
// ============================================================================

// Layouts paragraphs fix: reduce width of first level paragraphs who are not
// nested inside layout containers
// TODO: This needs further testing! Also this will probably conflict with the old ERL solution
.field--name-field-paragraphs {
  > .paragraph:not(.paragraph--type-layout):not(.paragraph--type-container),
  > .paragraph--type-container > .paragraph:not(.paragraph--type--bild-text--stretch-img-to-viewport),
  > .fancy-background-image > .paragraph:not(.box-style),
  > .fancy-background-image
    > .paragraph.box-style
    > .paragraph:not(.paragraph--type--bild-text--stretch-img-to-viewport) {
    @include xy-grid-container;
  }
}

// Define default spacings
.paragraph {
  &:not([class*="mb-"]) {
    margin-bottom: $global-margin;
  }
  // -- Container types
  &--type-container,
  &--type-erl-section {
    &:not([class*="pt-"]) {
      // TODO: #d9deprecated - the space mixin is our new default with d9 remove this check everywhere
      @if (variable-exists(spacings-responsive) and $spacings-responsive == true) {
        @include space(lg, top, padding);
      } @else {
        padding-top: $space-lg-v;
      }
    }
    &:not([class*="pb-"]) {
      @if (variable-exists(spacings-responsive) and $spacings-responsive == true) {
        @include space(lg, bottom, padding);
      } @else {
        padding-bottom: $space-lg-v;
      }
    }
  }
}

// Remove default spacing in some cases
.cell > .paragraph:not([class*="mb-"]):last-child,
.fancy-background-image__img-wrapper + .paragraph:not([class*="mb-"]):last-child {
  margin-bottom: 0;
}

// Remove global margin (bottom) on components (since all paragraphs have default spacings
.paragraph {
  > .card,
  > .media-object,
  > .media-entity--embedded .responsive-embed {
    margin-bottom: 0;
  }
}

// ============================================================================
// Misc paragraph fixes
// ============================================================================

.paragraph {
  // Fix vertical alignment on min-height containers
  &[class*="min-height"] {
    display: flex;
    flex-direction: column;
    justify-content: center;
  }
  // Prevent double spacing at the bottom - we dont do this for all (*) elements, because sometimes you will put just an title in a single paragraph,
  // so this would destroy our default text style.
  > .button,
  > p,
  > * > .button {
    &:last-child {
      margin-bottom: 0;
    }
  }
  // Remove horizontal extra margins on smaller devices
  &[class*="ml-"],
  &[class*="mr-"] {
    @include breakpoint(large down) {
      margin-left: 0;
      margin-right: 0;
    }
  }
}

// Fix Layout sections (Layout Paragraphs type) with box style (remove double hor. spacings)
// TODO: This causes errors in other cases! Check if still needed.
// .paragraph--type-layout {
//   &.box-style:not(.paragraph--page-width) {
//     padding-left: 0;
//     padding-right: 0;
//   }
// }

// ============================================================================
// Types
// ============================================================================

// Slide Container
.paragraph--type-container-slides {
  > .slick,
  > .slick .slick__slider,
  > .slick .slick-list{
    height:100%;
  }
  .slick-track {
    // Equal height slides with flexbox
    display: flex;
    height: 100%; // TODO: slicks autoheight feature is not working with flex and height 100%
    &::before,
    &::after {
      display: none;
    }
  }
  .slick__slide {
    height: auto;
    > .paragraph,
    > .layout-wrapper,
    > .layout-wrapper > .paragraph {
      height: 100%;
    }
  } // If min-height set to the container stretch the slides to this height
  &[class*="min-height-"] {
    display: flex;
    flex-direction: column;
    .slick {
      flex: 1;
      height: 100%;
      &-list,
      &__slider {
        height: 100%;
      }
    }
  }
  // Show controls outside the slideshow so that content isn't overlayed
  &--controlsoutside {
    .slick{
      @include slick-controls-outside();
    }
  }
}

// Entityreference
.paragraph--type-entityreference {
  &:only-child {
    height: 100%;
    margin-bottom: 0;
  }
}

// Maps
.paragraph--type-simple-map {
  height: calc(100% - #{$global-margin});
  margin-bottom: $global-margin;
}
.cell{
  > .paragraph--type-simple-map{
    iframe{
      height:100%;
    }
  }
}
